
package com.archeus.test;

import java.net.MalformedURLException;
import java.util.Collection;
import java.util.HashMap;
import javax.xml.namespace.QName;
import org.codehaus.xfire.XFireRuntimeException;
import org.codehaus.xfire.aegis.AegisBindingProvider;
import org.codehaus.xfire.annotations.AnnotationServiceFactory;
import org.codehaus.xfire.annotations.jsr181.Jsr181WebAnnotations;
import org.codehaus.xfire.client.XFireProxyFactory;
import org.codehaus.xfire.jaxb2.JaxbTypeRegistry;
import org.codehaus.xfire.service.Endpoint;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.soap.AbstractSoapBinding;
import org.codehaus.xfire.transport.TransportManager;

public class LemmatizerServiceServiceClient {

	private static XFireProxyFactory proxyFactory = new XFireProxyFactory();

	private HashMap endpoints = new HashMap();

	private Service service0;

	public LemmatizerServiceServiceClient() {
		create0();
		Endpoint LemmatizerServiceLocalEndpointEP = service0
				.addEndpoint(
						new QName(
								"http://www.archeus.ro/lingvistica/services/Lemmatizer",
								"LemmatizerServiceLocalEndpoint"),
						new QName(
								"http://www.archeus.ro/lingvistica/services/Lemmatizer",
								"LemmatizerServiceLocalBinding"),
						"xfire.local://LemmatizerServiceService");
		endpoints.put(new QName(
				"http://www.archeus.ro/lingvistica/services/Lemmatizer",
				"LemmatizerServiceLocalEndpoint"),
				LemmatizerServiceLocalEndpointEP);
		Endpoint LemmatizerEP = service0.addEndpoint(new QName(
				"http://www.archeus.ro/lingvistica/services/Lemmatizer",
				"Lemmatizer"), new QName(
				"http://www.archeus.ro/lingvistica/services/Lemmatizer",
				"LemmatizerSoapBinding"),
				"http://www.archeus.ro/lingvistica/services/Lemmatizer");
		endpoints.put(new QName(
				"http://www.archeus.ro/lingvistica/services/Lemmatizer",
				"Lemmatizer"), LemmatizerEP);
	}

	public Object getEndpoint(Endpoint endpoint) {
		try {
			return proxyFactory.create((endpoint).getBinding(), (endpoint)
					.getUrl());
		} catch (MalformedURLException e) {
			throw new XFireRuntimeException("Invalid URL", e);
		}
	}

	public Object getEndpoint(QName name) {
		Endpoint endpoint = ((Endpoint) endpoints.get((name)));
		if ((endpoint) == null) {
			throw new IllegalStateException("No such endpoint!");
		}
		return getEndpoint((endpoint));
	}

	public Collection getEndpoints() {
		return endpoints.values();
	}

	private void create0() {
		TransportManager tm = (org.codehaus.xfire.XFireFactory.newInstance()
				.getXFire().getTransportManager());
		HashMap props = new HashMap();
		props.put("annotations.allow.interface", true);
		AnnotationServiceFactory asf = new AnnotationServiceFactory(
				new Jsr181WebAnnotations(), tm, new AegisBindingProvider(
						new JaxbTypeRegistry()));
		asf.setBindingCreationEnabled(false);
		service0 = asf
				.create((com.archeus.test.LemmatizerService.class), props);
		{
			AbstractSoapBinding soapBinding = asf
					.createSoap11Binding(
							service0,
							new QName(
									"http://www.archeus.ro/lingvistica/services/Lemmatizer",
									"LemmatizerServiceLocalBinding"),
							"urn:xfire:transport:local");
		}
		{
			AbstractSoapBinding soapBinding = asf
					.createSoap11Binding(
							service0,
							new QName(
									"http://www.archeus.ro/lingvistica/services/Lemmatizer",
									"LemmatizerSoapBinding"),
							"http://schemas.xmlsoap.org/soap/http");
		}
	}

	public LemmatizerService getLemmatizerServiceLocalEndpoint() {
		return ((LemmatizerService) (this).getEndpoint(new QName(
				"http://www.archeus.ro/lingvistica/services/Lemmatizer",
				"LemmatizerServiceLocalEndpoint")));
	}

	public LemmatizerService getLemmatizerServiceLocalEndpoint(String url) {
		LemmatizerService var = getLemmatizerServiceLocalEndpoint();
		org.codehaus.xfire.client.Client.getInstance(var).setUrl(url);
		return var;
	}

	public LemmatizerService getLemmatizer() {
		return ((LemmatizerService) (this).getEndpoint(new QName(
				"http://www.archeus.ro/lingvistica/services/Lemmatizer",
				"Lemmatizer")));
	}

	public LemmatizerService getLemmatizer(String url) {
		LemmatizerService var = getLemmatizer();
		org.codehaus.xfire.client.Client.getInstance(var).setUrl(url);
		return var;
	}

	public static void main(String[] args) {

		LemmatizerServiceServiceClient client = new LemmatizerServiceServiceClient();

		//create a default service endpoint
		LemmatizerService service = client.getLemmatizer();

//		*********************************************
		// codul de pana aici a fost generat automat de IDE (Eclipse)
		//*********************************************

		String lang = "ro";
		String word = "cartea";
		System.out.println(service.lemmatizeWord(word, lang));
		

		System.out.println("test client completed");
		System.exit(0);
	}

}
